#version 150

out vec4 fragColor;

in vec2 v_texCoord;
uniform int a_FlagType;
uniform vec4 a_FlagColor;

#define TYPE_CHECKPOINT 1
#define TYPE_END 2
#define CHECKBOARD_SIZE 20

//HOTSPOT_PRE_MAIN

vec4 checkboard(vec2 texPos) {
	vec2 p = texPos*CHECKBOARD_SIZE;
	float row = floor(p.x);
	float col = floor(p.y);
	float c = mod(row + col, 2.0);
	float cD = fwidth(c);
	c = c - cD/7;
	return vec4(c, c, c, 0);
}

void main()
{
	if(a_FlagType == TYPE_END) {
		fragColor = checkboard(v_texCoord);
	}
	else {
		fragColor = a_FlagColor;
	}
}