#version 150

uniform bool a_Opaque;
uniform float a_OpaqueStart;
uniform float a_OpaqueEnd;
uniform float osg_SimulationTime;

in vec3 v_WoodCoord;
in vec4 v_Vertex;

out vec4 fragColor;

//HOTSPOT_PRE_MAIN

void main()
{
	float alpha = easeLinear(a_OpaqueStart, a_OpaqueEnd, osg_SimulationTime);
	if(a_Opaque) {
		alpha = 1-alpha;
	}
	fragColor = woodColor(v_WoodCoord) + vec4(1,1,1,0)*v_Vertex.z / 7.0 - vec4(0,0,0,alpha);
	fragColor = phong(fragColor*0.8, fragColor*0.4, fragColor*0.1, 15);
}

