#version 150

uniform mat4 osg_ProjectionMatrix;
uniform mat4 osg_ViewMatrix;

uniform bool a_PortalActive;
uniform mat4 a_PortalSenderMatrix;
uniform mat4 a_PortalReceiverMatrix;
uniform mat4 a_PortalRotationMatrix;

layout(triangles) in;
layout(triangle_strip, max_vertices = 9) out;

in vec4 v_Color[3];
out vec4 g_Color;

in vec3 phong_v_LightPos[3];
out vec3 phong_LightPos;
in vec3 phong_v_Vertex[3];
out vec3 phong_Vertex;
in vec3 phong_v_Normal[3];
out vec3 phong_Normal;

void main() {
	for(int i = 0; i < 3; i++) {
		g_Color = v_Color[i];
		
		phong_LightPos = phong_v_LightPos[i];
		phong_Vertex = phong_v_Vertex[i];
		phong_Normal = phong_v_Normal[i];
		
		gl_Position = gl_in[i].gl_Position;
		EmitVertex();
	}
	EndPrimitive();
	
	if(a_PortalActive) {		
		for(int i = 0; i < 3; i++) {
			g_Color = v_Color[i];
			vec4 posInView = inverse(osg_ProjectionMatrix) * gl_in[i].gl_Position;
			vec4 posInGlobe = inverse(osg_ViewMatrix) * posInView;
			
			vec4 newPosInSender = inverse(a_PortalSenderMatrix)*posInGlobe;
			vec4 rotatedPos = a_PortalRotationMatrix * newPosInSender;
			vec4 newPosInReceiver = a_PortalReceiverMatrix * rotatedPos;
			
			gl_Position = osg_ProjectionMatrix * osg_ViewMatrix * newPosInReceiver;
			EmitVertex();
		}
		EndPrimitive();
	}
}