#version 150

in vec4 osg_Vertex;
in vec4 osg_Color;
in vec4 osg_MultiTexCoord0;

uniform mat4 osg_ModelViewMatrix;
uniform mat4 osg_ProjectionMatrix;
uniform float osg_SimulationTime;

uniform float a_startTime;
uniform float a_timeIn;
uniform float a_timeUp;
uniform float a_timeOut;

out vec4 v_Color;
out vec2 v_texCoord;

// Distance from bottom to the displayed position
const float c_yUp = 0.4;

void main()
{
	v_Color = osg_Color;
	gl_Position = osg_ProjectionMatrix * osg_ModelViewMatrix * osg_Vertex;
	float timePassed = (osg_SimulationTime - a_startTime);
	float diff = smoothstep(0, 1, timePassed / a_timeIn) * c_yUp - c_yUp;
	if (timePassed > a_timeIn + a_timeUp) 
		diff = smoothstep(1, 0, (timePassed - a_timeIn - a_timeUp) / a_timeOut) * c_yUp - c_yUp;
	else if (timePassed > a_timeIn)
		diff = 0;
	gl_Position += vec4(0, diff, 0, 0);
	v_texCoord = osg_MultiTexCoord0.xy;
}