in vec3 phong_LightPos;
in vec3 phong_Vertex;
in vec3 phong_Normal;

vec4 phong(vec4 ambientColor, vec4 diffuseColor, vec4 specularColor, float shininess) {
	vec3 L = normalize(phong_LightPos - phong_Vertex);
	vec3 E = normalize(-phong_Vertex); // we are in Eye Coordinates, so EyePos is (0,0,0)
	vec3 R = normalize(-reflect(L,phong_Normal));
	// calculate Diffuse Term:
	vec4 Idiff = diffuseColor * max(dot(phong_Normal,L), 0.0);
	Idiff = clamp(Idiff, 0.0, 1.0);
	// calculate Specular Term:
	vec4 Ispec = specularColor * pow(max(dot(R,E),0.0),shininess);
	Ispec = clamp(Ispec, 0.0, 1.0);
	// calculate final color:
	return ambientColor + Idiff + Ispec;
}

vec4 phong(vec4 ambientColor, vec4 diffuseColor) {
	vec3 L = normalize(phong_LightPos - phong_Vertex);
	// calculate Diffuse Term:
	vec4 Idiff = diffuseColor * max(dot(phong_Normal,L), 0.0);
	Idiff = clamp(Idiff, 0.0, 1.0);
	// calculate final color:
	return ambientColor + Idiff;
}